#!/usr/bin/perl -w
#
#####################################################################################################
#
#   				(c) Markus Hoffmann, 2005-open end
#
#####################################################################################################
#
# COPYRIGHT NOTICE                                                        
# Copyright 2005 Markus Hoffmann
# All Rights Reserved.                     
# EMail: ipcop@mh-lantech.de
# URL  : http://www.mhaddons.tk
#
# License: CreativeCommons, some right restricted ( http://creativecommons.org/licenses/by-nd/2.5/ )
#
#####################################################################################################
#
# 				    Im Script muss nichts veraendert werden
#				Nothings got to be changed in this script to work
#
#####################################################################################################
#

use strict;

my $i;
my @RULES;
my @line;
my @tmp;
my $count=0;

if ( -e "/var/ipcop/qos/settings/layer7/rules" && -e "/var/ipcop/qos/settings/other/rules" ) {
	print "Checking/converting layer rules:\n";
	@RULES=`cat /var/ipcop/qos/settings/layer7/rules`;
	if ( @RULES > 0 ) {
		open( FILE, "> /var/ipcop/qos/settings/layer7/rules" ) or die "Unable to write /var/ipcop/qos/settings/layer7/rules";
		foreach $i ( @RULES )
		{
			chomp($i);
			@line=split(/\;/, $i);
			if ( $i =~ /0x[0-9+]/ ) { 
				print "\tlayer7 rule: $line[0] ok\n";
				print FILE "$i\n";
			} else {
				print "\tlayer7 rule: $line[0] converted\n";
				print FILE "$i;0x00\n";	
			}
		}
		close FILE;
	}
	print "Done\n\n";
	print "Checking/converting rules:\n";
	@RULES=`cat /var/ipcop/qos/settings/other/rules`;
	if ( @RULES > 0 ) {
		open( FILE, "> /var/ipcop/qos/settings/other/rules" ) or die "Unable to write /var/ipcop/qos/settings/other/rules";
		foreach $i ( @RULES )
		{
			chomp($i);
			@line=split(/\;/, $i);
			if ( $i =~ /0x[0-9+]/ ) { 
				print "\trule: $line[0] ok\n";
				print FILE "$i\n";
			} else {
				print "\trule: $line[0] converted\n";
				print FILE "$i;0x00\n";
			}
		}
		close FILE;
	}
	print "Done\n\n";

	print "Merging rules into one file:\n";
	@RULES=`cat /var/ipcop/qos/settings/layer7/rules`;
	if ( @RULES > 0 ) {
		open( FILE, "> /var/ipcop/qos/settings/rules" ) or die "Unable to write /var/ipcop/qos/settings/rules";
		foreach $i ( @RULES )
		{
			chomp($i);
			@line=split(/\;/, $i);
			if ( $i =~ /^l7/ ) { 
				print "\tlayer7 rule: $line[0] ok\n";
				print FILE "$i\n";
			} else {
				print "\tlayer7 rule: $line[0] converted\n";
				print FILE "l7;$i\n";	
			}
		}
		close FILE;
		@RULES=`cat /var/ipcop/qos/settings/other/rules`;
		open( FILE, ">> /var/ipcop/qos/settings/rules" ) or die "Unable to write /var/ipcop/qos/settings/rules";
		foreach $i ( @RULES )
		{
			chomp($i);
			@line=split(/\;/, $i);
			if ( $i =~ /^port/ ) { 
				print "\trule: $line[0] ok\n";
				print FILE "$i\n";
			} else {
				print "\trule: $line[0] converted\n";
				print FILE "port;$i\n";
			}
		}
		close FILE;
	}
	print "Done\n\n";

	&sortrules;

	system("rm -rf /var/ipcop/qos/settings/other");
	system("rm -rf /var/ipcop/qos/settings/layer7");

	system("chown nobody:nobody /var/ipcop/qos/settings/rules");
}

if ( -e "/var/ipcop/qos/settings/rules" ) {

	system("mkdir -p /var/ipcop/qos/settings/other");
	system("mkdir -p  /var/ipcop/qos/settings/layer7");
	@RULES=`cat /var/ipcop/qos/settings/rules`;

	open( FILE, "> /var/ipcop/qos/settings/layer7/rules" ) or die "Unable to write /var/ipcop/qos/settings/layer7/rules";
	foreach $i ( @RULES )
	{
		chomp($i);
		@line=split(/\;/, $i);
		if ( $line[0] eq "l7" ) {
			print FILE $line[1].";".$line[2].";".$line[3].";".$line[4].";".$line[5].";".$line[6].";".$line[7]."\n";
		}
	}
	close FILE;
	open( FILE, "> /var/ipcop/qos/settings/other/rules" ) or die "Unable to write /var/ipcop/qos/settings/other/rules";
	foreach $i ( @RULES )
	{
print $i;
		chomp($i);
		@line=split(/\;/, $i);
print $line[0]."\n";
		if ( $line[0] eq "port" ) {
			print FILE $line[1].";".$line[2].";".$line[3].";".$line[4].";".$line[5].";".$line[6].";".$line[7].";".$line[8].";".$line[9]."\n";
		}
	}
	close FILE;

	system("chown nobody:nobody /var/ipcop/qos/settings/layer7/rules");
	system("chown nobody:nobody /var/ipcop/qos/settings/other/rules");
	system("rm -f /var/ipcop/qos/settings/rules");
}

exit 0;

sub mySort {
    my $v1 = (split (/;/, $a))[1];
    my $v2 = (split (/;/, $b))[1];
    $v1 cmp $v2;   
}

sub sortrules {
	open( FILE, "< /var/ipcop/qos/settings/rules" ) or die "Unable to read rulefile";
	@tmp = <FILE>;
	close FILE;
	$count=0;
	foreach my $s (@tmp) {
		chomp ($s);
		if ( ! $s ) { splice(@tmp,$count); }
		$count++;
	}
	open( FILE, "> /var/ipcop/qos/settings/rules" ) or die "Unable to write rulefile";
	foreach my $s (sort mySort (@tmp)) { print FILE $s."\n"; }
	close FILE;
}
